from edison_dictionary_api import EdisonBaseAPI


class briefsController(EdisonBaseAPI):
    """Briefs."""

    _controller_name = "briefsController"

    def add(self, brief, entityId, languageId):
        """

        Args:
            brief: (string): brief
            entityId: (string): entityId
            languageId: (string): languageId

        Returns:
            application/json;charset=UTF-8
        """

        all_api_parameters = {'brief': {'name': 'brief', 'required': True, 'in': 'query'}, 'entityId': {'name': 'entityId', 'required': True, 'in': 'query'}, 'languageId': {'name': 'languageId', 'required': True, 'in': 'query'}}
        parameters_names_map = {}
        api = '/briefs/add'
        actions = ['post']
        params, data = self._format_params_for_api(locals(), all_api_parameters, parameters_names_map)
        return self._process_api(self._controller_name, api, actions, params, data)

    def edit(self, brief, briefId):
        """

        Args:
            brief: (string): brief
            briefId: (string): briefId

        Returns:
            application/json;charset=UTF-8
        """

        all_api_parameters = {'brief': {'name': 'brief', 'required': True, 'in': 'query'}, 'briefId': {'name': 'briefId', 'required': True, 'in': 'query'}}
        parameters_names_map = {}
        api = '/briefs/edit'
        actions = ['post']
        params, data = self._format_params_for_api(locals(), all_api_parameters, parameters_names_map)
        return self._process_api(self._controller_name, api, actions, params, data)

    def list(self, entityId):
        """

        Args:
            entityId: (string): entityId

        Returns:
            application/json;charset=UTF-8
        """

        all_api_parameters = {'entityId': {'name': 'entityId', 'required': True, 'in': 'query'}}
        parameters_names_map = {}
        api = '/briefs/list'
        actions = ['post']
        params, data = self._format_params_for_api(locals(), all_api_parameters, parameters_names_map)
        return self._process_api(self._controller_name, api, actions, params, data)

    def remove(self, briefId):
        """

        Args:
            briefId: (string): briefId

        Returns:
            application/json;charset=UTF-8
        """

        all_api_parameters = {'briefId': {'name': 'briefId', 'required': True, 'in': 'query'}}
        parameters_names_map = {}
        api = '/briefs/remove'
        actions = ['post']
        params, data = self._format_params_for_api(locals(), all_api_parameters, parameters_names_map)
        return self._process_api(self._controller_name, api, actions, params, data)

    def retrieve(self, briefId):
        """

        Args:
            briefId: (string): briefId

        Returns:
            application/json;charset=UTF-8
        """

        all_api_parameters = {'briefId': {'name': 'briefId', 'required': True, 'in': 'query'}}
        parameters_names_map = {}
        api = '/briefs/retrieve'
        actions = ['post']
        params, data = self._format_params_for_api(locals(), all_api_parameters, parameters_names_map)
        return self._process_api(self._controller_name, api, actions, params, data)
