from edison_dictionary_api import EdisonBaseAPI


class clustersDocumentsController(EdisonBaseAPI):
    """Clusters documents"""

    _controller_name = "clustersDocumentsController"

    def add(self, clusterLanguageId, text, **kwargs):
        """

        Args:
            clusterLanguageId: (string): clusterLanguageId
            text: (type): text
            weight: (number): weight

        Returns:
            application/json;charset=UTF-8
        """

        all_api_parameters = {'clusterLanguageId': {'name': 'clusterLanguageId', 'required': True, 'in': 'query'}, 'text': {'name': 'text', 'required': True, 'in': 'body'}, 'weight': {'name': 'weight', 'required': False, 'in': 'query'}}
        parameters_names_map = {}
        api = '/clusters-documents/add'
        actions = ['post']
        params, data = self._format_params_for_api(locals(), all_api_parameters, parameters_names_map)
        return self._process_api(self._controller_name, api, actions, params, data)

    def addFile(self, clusterLanguageId, files, **kwargs):
        """Supported file formats: https://tika.apache.org/1.13/formats.html

        Args:
            clusterLanguageId: (type): clusterLanguageId
            files: (array): files
            splitByLines: (type): splitByLines

        Returns:
            application/json;charset=UTF-8
        """

        all_api_parameters = {'clusterLanguageId': {'name': 'clusterLanguageId', 'required': True, 'in': 'formData'}, 'files': {'name': 'files', 'required': True, 'in': 'formData'}, 'splitByLines': {'name': 'splitByLines', 'required': False, 'in': 'formData'}}
        parameters_names_map = {}
        api = '/clusters-documents/addFile'
        actions = ['post']
        params, data = self._format_params_for_api(locals(), all_api_parameters, parameters_names_map)
        return self._process_api(self._controller_name, api, actions, params, data)

    def edit(self, clusterDocumentId, text, **kwargs):
        """

        Args:
            clusterDocumentId: (string): clusterDocumentId
            text: (type): text
            weight: (number): weight

        Returns:
            application/json;charset=UTF-8
        """

        all_api_parameters = {'clusterDocumentId': {'name': 'clusterDocumentId', 'required': True, 'in': 'query'}, 'text': {'name': 'text', 'required': True, 'in': 'body'}, 'weight': {'name': 'weight', 'required': False, 'in': 'query'}}
        parameters_names_map = {}
        api = '/clusters-documents/edit'
        actions = ['post']
        params, data = self._format_params_for_api(locals(), all_api_parameters, parameters_names_map)
        return self._process_api(self._controller_name, api, actions, params, data)

    def list(self, clusterLanguageId, **kwargs):
        """

        Args:
            clusterLanguageId: (string): clusterLanguageId
            maxLength: (integer): maxLength
            maxNumber: (integer): maxNumber
            offset: (integer): offset
            sortMode: (string): { "weight", "proximity", "doc2vec", "keywords", "entities" }
            sortOrderAscending: (boolean): true = ascending (default); false = descending

        Returns:
            application/json;charset=UTF-8
        """

        all_api_parameters = {'clusterLanguageId': {'name': 'clusterLanguageId', 'required': True, 'in': 'query'}, 'maxLength': {'name': 'maxLength', 'required': False, 'in': 'query'}, 'maxNumber': {'name': 'maxNumber', 'required': False, 'in': 'query'}, 'offset': {'name': 'offset', 'required': False, 'in': 'query'}, 'sortMode': {'name': 'sortMode', 'required': False, 'in': 'query'}, 'sortOrderAscending': {'name': 'sortOrderAscending', 'required': False, 'in': 'query'}}
        parameters_names_map = {}
        api = '/clusters-documents/list'
        actions = ['post']
        params, data = self._format_params_for_api(locals(), all_api_parameters, parameters_names_map)
        return self._process_api(self._controller_name, api, actions, params, data)

    def remove(self, clusterDocumentId):
        """

        Args:
            clusterDocumentId: (string): clusterDocumentId

        Returns:
            application/json;charset=UTF-8
        """

        all_api_parameters = {'clusterDocumentId': {'name': 'clusterDocumentId', 'required': True, 'in': 'query'}}
        parameters_names_map = {}
        api = '/clusters-documents/remove'
        actions = ['post']
        params, data = self._format_params_for_api(locals(), all_api_parameters, parameters_names_map)
        return self._process_api(self._controller_name, api, actions, params, data)

    def retrieve(self, clusterDocumentId):
        """

        Args:
            clusterDocumentId: (string): clusterDocumentId

        Returns:
            application/json;charset=UTF-8
        """

        all_api_parameters = {'clusterDocumentId': {'name': 'clusterDocumentId', 'required': True, 'in': 'query'}}
        parameters_names_map = {}
        api = '/clusters-documents/retrieve'
        actions = ['post']
        params, data = self._format_params_for_api(locals(), all_api_parameters, parameters_names_map)
        return self._process_api(self._controller_name, api, actions, params, data)
