from edison_dictionary_api import EdisonBaseAPI


class clustersManagementController(EdisonBaseAPI):
    """Clusters management"""

    _controller_name = "clustersManagementController"

    def clusterize(self, clusterLanguageId, **kwargs):
        """

        Args:
            clusterLanguageId: (string): clusterLanguageId
            iterations: (integer): iterations
            maxClusters: (integer): maxClusters
            maxNames: (integer): maxNames
            minClusters: (integer): minClusters
            seed: (integer): seed

        Returns:
            application/json;charset=UTF-8
        """

        all_api_parameters = {'clusterLanguageId': {'name': 'clusterLanguageId', 'required': True, 'in': 'query'}, 'iterations': {'name': 'iterations', 'required': False, 'in': 'query'}, 'maxClusters': {'name': 'maxClusters', 'required': False, 'in': 'query'}, 'maxNames': {'name': 'maxNames', 'required': False, 'in': 'query'}, 'minClusters': {'name': 'minClusters', 'required': False, 'in': 'query'}, 'seed': {'name': 'seed', 'required': False, 'in': 'query'}}
        parameters_names_map = {}
        api = '/clusters-management/clusterize'
        actions = ['post']
        params, data = self._format_params_for_api(locals(), all_api_parameters, parameters_names_map)
        return self._process_api(self._controller_name, api, actions, params, data)

    def copy(self, destineSubclassLanguageId, sourceSubclassLanguageId):
        """

        Args:
            destineSubclassLanguageId: (string): destineSubclassLanguageId
            sourceSubclassLanguageId: (string): sourceSubclassLanguageId

        Returns:
            application/json;charset=UTF-8
        """

        all_api_parameters = {'destineSubclassLanguageId': {'name': 'destineSubclassLanguageId', 'required': True, 'in': 'query'}, 'sourceSubclassLanguageId': {'name': 'sourceSubclassLanguageId', 'required': True, 'in': 'query'}}
        parameters_names_map = {}
        api = '/clusters-management/copy'
        actions = ['post']
        params, data = self._format_params_for_api(locals(), all_api_parameters, parameters_names_map)
        return self._process_api(self._controller_name, api, actions, params, data)

    def findNames(self, clusterLanguageId, **kwargs):
        """

        Args:
            clusterLanguageId: (string): clusterLanguageId
            maxNames: (integer): maxNames

        Returns:
            application/json;charset=UTF-8
        """

        all_api_parameters = {'clusterLanguageId': {'name': 'clusterLanguageId', 'required': True, 'in': 'query'}, 'maxNames': {'name': 'maxNames', 'required': False, 'in': 'query'}}
        parameters_names_map = {}
        api = '/clusters-management/findNames'
        actions = ['post']
        params, data = self._format_params_for_api(locals(), all_api_parameters, parameters_names_map)
        return self._process_api(self._controller_name, api, actions, params, data)

    def visualize(self, className, languageId):
        """

        Args:
            className: (string): { "themes", "doctypes", "emotions", "sentiments", "clusters" }
            languageId: (string): languageId

        Returns:
            application/json;charset=UTF-8
        """

        all_api_parameters = {'className': {'name': 'className', 'required': True, 'in': 'query'}, 'languageId': {'name': 'languageId', 'required': True, 'in': 'query'}}
        parameters_names_map = {}
        api = '/clusters-management/visualize'
        actions = ['post']
        params, data = self._format_params_for_api(locals(), all_api_parameters, parameters_names_map)
        return self._process_api(self._controller_name, api, actions, params, data)
