from edison_dictionary_api import EdisonBaseAPI


class databasesController(EdisonBaseAPI):
    """Databases."""

    _controller_name = "databasesController"

    def backup(self, **kwargs):
        """

        Args:
            incremental: (boolean): incremental
            removeFolder: (boolean): removeFolder
            zip: (boolean): zip

        Returns:
            application/json;charset=UTF-8
        """

        all_api_parameters = {'incremental': {'name': 'incremental', 'required': False, 'in': 'query'}, 'removeFolder': {'name': 'removeFolder', 'required': False, 'in': 'query'}, 'zip': {'name': 'zip', 'required': False, 'in': 'query'}}
        parameters_names_map = {}
        api = '/databases/backup'
        actions = ['post']
        params, data = self._format_params_for_api(locals(), all_api_parameters, parameters_names_map)
        return self._process_api(self._controller_name, api, actions, params, data)

    def clusterArchive(self, clusterLanguageId):
        """

        Args:
            clusterLanguageId: (string): clusterLanguageId

        Returns:
            application/json;charset=UTF-8
        """

        all_api_parameters = {'clusterLanguageId': {'name': 'clusterLanguageId', 'required': True, 'in': 'query'}}
        parameters_names_map = {}
        api = '/databases/clusterArchive'
        actions = ['post']
        params, data = self._format_params_for_api(locals(), all_api_parameters, parameters_names_map)
        return self._process_api(self._controller_name, api, actions, params, data)

    def doctypeArchive(self, doctypeLanguageId):
        """

        Args:
            doctypeLanguageId: (string): doctypeLanguageId

        Returns:
            application/json;charset=UTF-8
        """

        all_api_parameters = {'doctypeLanguageId': {'name': 'doctypeLanguageId', 'required': True, 'in': 'query'}}
        parameters_names_map = {}
        api = '/databases/doctypeArchive'
        actions = ['post']
        params, data = self._format_params_for_api(locals(), all_api_parameters, parameters_names_map)
        return self._process_api(self._controller_name, api, actions, params, data)

    def downloadClusterDocuments(self, clusterLanguageId):
        """

        Args:
            clusterLanguageId: (string): clusterLanguageId

        Returns:
            application/json;charset=UTF-8
        """

        all_api_parameters = {'clusterLanguageId': {'name': 'clusterLanguageId', 'required': True, 'in': 'query'}}
        parameters_names_map = {}
        api = '/databases/downloadClusterDocuments'
        actions = ['post']
        params, data = self._format_params_for_api(locals(), all_api_parameters, parameters_names_map)
        return self._process_api(self._controller_name, api, actions, params, data)

    def downloadDoctypeDocuments(self, doctypeLanguageId):
        """

        Args:
            doctypeLanguageId: (string): doctypeLanguageId

        Returns:
            application/json;charset=UTF-8
        """

        all_api_parameters = {'doctypeLanguageId': {'name': 'doctypeLanguageId', 'required': True, 'in': 'query'}}
        parameters_names_map = {}
        api = '/databases/downloadDoctypeDocuments'
        actions = ['post']
        params, data = self._format_params_for_api(locals(), all_api_parameters, parameters_names_map)
        return self._process_api(self._controller_name, api, actions, params, data)

    def downloadEmotionDocuments(self, emotionLanguageId):
        """

        Args:
            emotionLanguageId: (string): emotionLanguageId

        Returns:
            application/json;charset=UTF-8
        """

        all_api_parameters = {'emotionLanguageId': {'name': 'emotionLanguageId', 'required': True, 'in': 'query'}}
        parameters_names_map = {}
        api = '/databases/downloadEmotionDocuments'
        actions = ['post']
        params, data = self._format_params_for_api(locals(), all_api_parameters, parameters_names_map)
        return self._process_api(self._controller_name, api, actions, params, data)

    def downloadSentimentDocuments(self, sentimentLanguageId):
        """

        Args:
            sentimentLanguageId: (string): sentimentLanguageId

        Returns:
            application/json;charset=UTF-8
        """

        all_api_parameters = {'sentimentLanguageId': {'name': 'sentimentLanguageId', 'required': True, 'in': 'query'}}
        parameters_names_map = {}
        api = '/databases/downloadSentimentDocuments'
        actions = ['post']
        params, data = self._format_params_for_api(locals(), all_api_parameters, parameters_names_map)
        return self._process_api(self._controller_name, api, actions, params, data)

    def downloadThemeDocuments(self, themeLanguageId):
        """

        Args:
            themeLanguageId: (string): themeLanguageId

        Returns:
            application/json;charset=UTF-8
        """

        all_api_parameters = {'themeLanguageId': {'name': 'themeLanguageId', 'required': True, 'in': 'query'}}
        parameters_names_map = {}
        api = '/databases/downloadThemeDocuments'
        actions = ['post']
        params, data = self._format_params_for_api(locals(), all_api_parameters, parameters_names_map)
        return self._process_api(self._controller_name, api, actions, params, data)

    def downloadTopicTypeDocuments(self, topicTypeLanguageId):
        """

        Args:
            topicTypeLanguageId: (string): topicTypeLanguageId

        Returns:
            application/json;charset=UTF-8
        """

        all_api_parameters = {'topicTypeLanguageId': {'name': 'topicTypeLanguageId', 'required': True, 'in': 'query'}}
        parameters_names_map = {}
        api = '/databases/downloadTopicTypeDocuments'
        actions = ['post']
        params, data = self._format_params_for_api(locals(), all_api_parameters, parameters_names_map)
        return self._process_api(self._controller_name, api, actions, params, data)

    def emotionArchive(self, emotionLanguageId):
        """

        Args:
            emotionLanguageId: (string): emotionLanguageId

        Returns:
            application/json;charset=UTF-8
        """

        all_api_parameters = {'emotionLanguageId': {'name': 'emotionLanguageId', 'required': True, 'in': 'query'}}
        parameters_names_map = {}
        api = '/databases/emotionArchive'
        actions = ['post']
        params, data = self._format_params_for_api(locals(), all_api_parameters, parameters_names_map)
        return self._process_api(self._controller_name, api, actions, params, data)

    def sentimentArchive(self, sentimentLanguageId):
        """

        Args:
            sentimentLanguageId: (string): sentimentLanguageId

        Returns:
            application/json;charset=UTF-8
        """

        all_api_parameters = {'sentimentLanguageId': {'name': 'sentimentLanguageId', 'required': True, 'in': 'query'}}
        parameters_names_map = {}
        api = '/databases/sentimentArchive'
        actions = ['post']
        params, data = self._format_params_for_api(locals(), all_api_parameters, parameters_names_map)
        return self._process_api(self._controller_name, api, actions, params, data)

    def themeArchive(self, themeLanguageId):
        """

        Args:
            themeLanguageId: (string): themeLanguageId

        Returns:
            application/json;charset=UTF-8
        """

        all_api_parameters = {'themeLanguageId': {'name': 'themeLanguageId', 'required': True, 'in': 'query'}}
        parameters_names_map = {}
        api = '/databases/themeArchive'
        actions = ['post']
        params, data = self._format_params_for_api(locals(), all_api_parameters, parameters_names_map)
        return self._process_api(self._controller_name, api, actions, params, data)

    def topicTypeArchive(self, topicTypeLanguageId):
        """

        Args:
            topicTypeLanguageId: (string): topicTypeLanguageId

        Returns:
            application/json;charset=UTF-8
        """

        all_api_parameters = {'topicTypeLanguageId': {'name': 'topicTypeLanguageId', 'required': True, 'in': 'query'}}
        parameters_names_map = {}
        api = '/databases/topicTypeArchive'
        actions = ['post']
        params, data = self._format_params_for_api(locals(), all_api_parameters, parameters_names_map)
        return self._process_api(self._controller_name, api, actions, params, data)

    def updateBinaries(self):
        """"""

        all_api_parameters = {}
        parameters_names_map = {}
        api = '/databases/updateBinaries'
        actions = ['post']
        params, data = self._format_params_for_api(locals(), all_api_parameters, parameters_names_map)
        return self._process_api(self._controller_name, api, actions, params, data)

    def updateDictionaries(self, **kwargs):
        """

        Args:
            dictionaryId: (string): dictionaryId
            recalculateDocumentsVectors: (boolean): recalculateDocumentsVectors

        Returns:
            application/json;charset=UTF-8
        """

        all_api_parameters = {'dictionaryId': {'name': 'dictionaryId', 'required': False, 'in': 'query'}, 'recalculateDocumentsVectors': {'name': 'recalculateDocumentsVectors', 'required': False, 'in': 'query'}}
        parameters_names_map = {}
        api = '/databases/updateDictionaries'
        actions = ['post']
        params, data = self._format_params_for_api(locals(), all_api_parameters, parameters_names_map)
        return self._process_api(self._controller_name, api, actions, params, data)

    def updateDoc2vec(self):
        """"""

        all_api_parameters = {}
        parameters_names_map = {}
        api = '/databases/updateDoc2vec'
        actions = ['post']
        params, data = self._format_params_for_api(locals(), all_api_parameters, parameters_names_map)
        return self._process_api(self._controller_name, api, actions, params, data)

    def updateDoctypes(self, **kwargs):
        """

        Args:
            recalculateDocumentsVectors: (boolean): recalculateDocumentsVectors
            subclassId: (string): subclassId

        Returns:
            application/json;charset=UTF-8
        """

        all_api_parameters = {'recalculateDocumentsVectors': {'name': 'recalculateDocumentsVectors', 'required': False, 'in': 'query'}, 'subclassId': {'name': 'subclassId', 'required': False, 'in': 'query'}}
        parameters_names_map = {}
        api = '/databases/updateDoctypes'
        actions = ['post']
        params, data = self._format_params_for_api(locals(), all_api_parameters, parameters_names_map)
        return self._process_api(self._controller_name, api, actions, params, data)

    def updateEmotions(self, **kwargs):
        """

        Args:
            recalculateDocumentsVectors: (boolean): recalculateDocumentsVectors
            subclassId: (string): subclassId

        Returns:
            application/json;charset=UTF-8
        """

        all_api_parameters = {'recalculateDocumentsVectors': {'name': 'recalculateDocumentsVectors', 'required': False, 'in': 'query'}, 'subclassId': {'name': 'subclassId', 'required': False, 'in': 'query'}}
        parameters_names_map = {}
        api = '/databases/updateEmotions'
        actions = ['post']
        params, data = self._format_params_for_api(locals(), all_api_parameters, parameters_names_map)
        return self._process_api(self._controller_name, api, actions, params, data)

    def updateIdfModel(self):
        """"""

        all_api_parameters = {}
        parameters_names_map = {}
        api = '/databases/updateIdfModel'
        actions = ['post']
        params, data = self._format_params_for_api(locals(), all_api_parameters, parameters_names_map)
        return self._process_api(self._controller_name, api, actions, params, data)

    def updateSentiment(self, **kwargs):
        """

        Args:
            recalculateDocumentsVectors: (boolean): recalculateDocumentsVectors
            subclassId: (string): subclassId

        Returns:
            application/json;charset=UTF-8
        """

        all_api_parameters = {'recalculateDocumentsVectors': {'name': 'recalculateDocumentsVectors', 'required': False, 'in': 'query'}, 'subclassId': {'name': 'subclassId', 'required': False, 'in': 'query'}}
        parameters_names_map = {}
        api = '/databases/updateSentiment'
        actions = ['post']
        params, data = self._format_params_for_api(locals(), all_api_parameters, parameters_names_map)
        return self._process_api(self._controller_name, api, actions, params, data)

    def updateThemes(self, **kwargs):
        """

        Args:
            recalculateDocumentsVectors: (boolean): recalculateDocumentsVectors
            subclassId: (string): subclassId

        Returns:
            application/json;charset=UTF-8
        """

        all_api_parameters = {'recalculateDocumentsVectors': {'name': 'recalculateDocumentsVectors', 'required': False, 'in': 'query'}, 'subclassId': {'name': 'subclassId', 'required': False, 'in': 'query'}}
        parameters_names_map = {}
        api = '/databases/updateThemes'
        actions = ['post']
        params, data = self._format_params_for_api(locals(), all_api_parameters, parameters_names_map)
        return self._process_api(self._controller_name, api, actions, params, data)
