from edison_dictionary_api import EdisonBaseAPI


class doctypesDocumentsController(EdisonBaseAPI):
    """Doc-types documents"""

    _controller_name = "doctypesDocumentsController"

    def add(self, doctypeLanguageId, text, **kwargs):
        """

        Args:
            doctypeLanguageId: (string): doctypeLanguageId
            text: (type): text
            weight: (number): weight

        Returns:
            application/json;charset=UTF-8
        """

        all_api_parameters = {'doctypeLanguageId': {'name': 'doctypeLanguageId', 'required': True, 'in': 'query'}, 'text': {'name': 'text', 'required': True, 'in': 'body'}, 'weight': {'name': 'weight', 'required': False, 'in': 'query'}}
        parameters_names_map = {}
        api = '/doc-types-documents/add'
        actions = ['post']
        params, data = self._format_params_for_api(locals(), all_api_parameters, parameters_names_map)
        return self._process_api(self._controller_name, api, actions, params, data)

    def addFile(self, doctypeLanguageId, files, **kwargs):
        """Supported file formats: https://tika.apache.org/1.13/formats.html

        Args:
            doctypeLanguageId: (type): doctypeLanguageId
            files: (array): files
            splitByLines: (type): splitByLines

        Returns:
            application/json;charset=UTF-8
        """

        all_api_parameters = {'doctypeLanguageId': {'name': 'doctypeLanguageId', 'required': True, 'in': 'formData'}, 'files': {'name': 'files', 'required': True, 'in': 'formData'}, 'splitByLines': {'name': 'splitByLines', 'required': False, 'in': 'formData'}}
        parameters_names_map = {}
        api = '/doc-types-documents/addFile'
        actions = ['post']
        params, data = self._format_params_for_api(locals(), all_api_parameters, parameters_names_map)
        return self._process_api(self._controller_name, api, actions, params, data)

    def edit(self, doctypeDocumentId, text, **kwargs):
        """

        Args:
            doctypeDocumentId: (string): doctypeDocumentId
            text: (type): text
            weight: (number): weight

        Returns:
            application/json;charset=UTF-8
        """

        all_api_parameters = {'doctypeDocumentId': {'name': 'doctypeDocumentId', 'required': True, 'in': 'query'}, 'text': {'name': 'text', 'required': True, 'in': 'body'}, 'weight': {'name': 'weight', 'required': False, 'in': 'query'}}
        parameters_names_map = {}
        api = '/doc-types-documents/edit'
        actions = ['post']
        params, data = self._format_params_for_api(locals(), all_api_parameters, parameters_names_map)
        return self._process_api(self._controller_name, api, actions, params, data)

    def list(self, doctypeLanguageId, **kwargs):
        """

        Args:
            doctypeLanguageId: (string): doctypeLanguageId
            maxLength: (integer): maxLength
            maxNumber: (integer): maxNumber
            offset: (integer): offset
            sortMode: (string): { "weight", "proximity", "doc2vec", "keywords", "entities"}
            sortOrderAscending: (boolean): true = ascending (default); false = descending

        Returns:
            application/json;charset=UTF-8
        """

        all_api_parameters = {'doctypeLanguageId': {'name': 'doctypeLanguageId', 'required': True, 'in': 'query'}, 'maxLength': {'name': 'maxLength', 'required': False, 'in': 'query'}, 'maxNumber': {'name': 'maxNumber', 'required': False, 'in': 'query'}, 'offset': {'name': 'offset', 'required': False, 'in': 'query'}, 'sortMode': {'name': 'sortMode', 'required': False, 'in': 'query'}, 'sortOrderAscending': {'name': 'sortOrderAscending', 'required': False, 'in': 'query'}}
        parameters_names_map = {}
        api = '/doc-types-documents/list'
        actions = ['post']
        params, data = self._format_params_for_api(locals(), all_api_parameters, parameters_names_map)
        return self._process_api(self._controller_name, api, actions, params, data)

    def remove(self, doctypeDocumentId):
        """

        Args:
            doctypeDocumentId: (string): doctypeDocumentId

        Returns:
            application/json;charset=UTF-8
        """

        all_api_parameters = {'doctypeDocumentId': {'name': 'doctypeDocumentId', 'required': True, 'in': 'query'}}
        parameters_names_map = {}
        api = '/doc-types-documents/remove'
        actions = ['post']
        params, data = self._format_params_for_api(locals(), all_api_parameters, parameters_names_map)
        return self._process_api(self._controller_name, api, actions, params, data)

    def retrieve(self, doctypeDocumentId):
        """

        Args:
            doctypeDocumentId: (string): doctypeDocumentId

        Returns:
            application/json;charset=UTF-8
        """

        all_api_parameters = {'doctypeDocumentId': {'name': 'doctypeDocumentId', 'required': True, 'in': 'query'}}
        parameters_names_map = {}
        api = '/doc-types-documents/retrieve'
        actions = ['post']
        params, data = self._format_params_for_api(locals(), all_api_parameters, parameters_names_map)
        return self._process_api(self._controller_name, api, actions, params, data)
