from edison_dictionary_api import EdisonBaseAPI


class emotionsBlacklistKeywordsController(EdisonBaseAPI):
    """Keywords from a blacklist of a emotions"""

    _controller_name = "emotionsBlacklistKeywordsController"

    def add(self, emotionLanguageId, keyword):
        """

        Args:
            emotionLanguageId: (string): emotionLanguageId
            keyword: (string): keyword

        Returns:
            application/json;charset=UTF-8
        """

        all_api_parameters = {'emotionLanguageId': {'name': 'emotionLanguageId', 'required': True, 'in': 'query'}, 'keyword': {'name': 'keyword', 'required': True, 'in': 'query'}}
        parameters_names_map = {}
        api = '/emotions-blacklist-keywords/add'
        actions = ['post']
        params, data = self._format_params_for_api(locals(), all_api_parameters, parameters_names_map)
        return self._process_api(self._controller_name, api, actions, params, data)

    def list(self, emotionLanguageId, **kwargs):
        """

        Args:
            emotionLanguageId: (string): emotionLanguageId
            maxLength: (integer): maxLength
            maxNumber: (integer): maxNumber
            offset: (integer): offset
            sortOrderAscending: (boolean): true = ascending (default); false = descending

        Returns:
            application/json;charset=UTF-8
        """

        all_api_parameters = {'emotionLanguageId': {'name': 'emotionLanguageId', 'required': True, 'in': 'query'}, 'maxLength': {'name': 'maxLength', 'required': False, 'in': 'query'}, 'maxNumber': {'name': 'maxNumber', 'required': False, 'in': 'query'}, 'offset': {'name': 'offset', 'required': False, 'in': 'query'}, 'sortOrderAscending': {'name': 'sortOrderAscending', 'required': False, 'in': 'query'}}
        parameters_names_map = {}
        api = '/emotions-blacklist-keywords/list'
        actions = ['post']
        params, data = self._format_params_for_api(locals(), all_api_parameters, parameters_names_map)
        return self._process_api(self._controller_name, api, actions, params, data)

    def remove(self, keywordId):
        """

        Args:
            keywordId: (string): keywordId

        Returns:
            application/json;charset=UTF-8
        """

        all_api_parameters = {'keywordId': {'name': 'keywordId', 'required': True, 'in': 'query'}}
        parameters_names_map = {}
        api = '/emotions-blacklist-keywords/remove'
        actions = ['post']
        params, data = self._format_params_for_api(locals(), all_api_parameters, parameters_names_map)
        return self._process_api(self._controller_name, api, actions, params, data)

    def retrieve(self, keywordId):
        """

        Args:
            keywordId: (string): keywordId

        Returns:
            application/json;charset=UTF-8
        """

        all_api_parameters = {'keywordId': {'name': 'keywordId', 'required': True, 'in': 'query'}}
        parameters_names_map = {}
        api = '/emotions-blacklist-keywords/retrieve'
        actions = ['post']
        params, data = self._format_params_for_api(locals(), all_api_parameters, parameters_names_map)
        return self._process_api(self._controller_name, api, actions, params, data)
