from edison_dictionary_api import EdisonBaseAPI


class emotionsDocumentsController(EdisonBaseAPI):
    """Emotions documents"""

    _controller_name = "emotionsDocumentsController"

    def add(self, emotionLanguageId, text, **kwargs):
        """

        Args:
            emotionLanguageId: (string): emotionLanguageId
            text: (type): text
            weight: (number): weight

        Returns:
            application/json;charset=UTF-8
        """

        all_api_parameters = {'emotionLanguageId': {'name': 'emotionLanguageId', 'required': True, 'in': 'query'}, 'text': {'name': 'text', 'required': True, 'in': 'body'}, 'weight': {'name': 'weight', 'required': False, 'in': 'query'}}
        parameters_names_map = {}
        api = '/emotions-documents/add'
        actions = ['post']
        params, data = self._format_params_for_api(locals(), all_api_parameters, parameters_names_map)
        return self._process_api(self._controller_name, api, actions, params, data)

    def addFile(self, emotionLanguageId, files, **kwargs):
        """Supported file formats: https://tika.apache.org/1.13/formats.html

        Args:
            emotionLanguageId: (type): emotionLanguageId
            files: (array): files
            splitByLines: (type): splitByLines

        Returns:
            application/json;charset=UTF-8
        """

        all_api_parameters = {'emotionLanguageId': {'name': 'emotionLanguageId', 'required': True, 'in': 'formData'}, 'files': {'name': 'files', 'required': True, 'in': 'formData'}, 'splitByLines': {'name': 'splitByLines', 'required': False, 'in': 'formData'}}
        parameters_names_map = {}
        api = '/emotions-documents/addFile'
        actions = ['post']
        params, data = self._format_params_for_api(locals(), all_api_parameters, parameters_names_map)
        return self._process_api(self._controller_name, api, actions, params, data)

    def edit(self, emotionDocumentId, text, **kwargs):
        """

        Args:
            emotionDocumentId: (string): emotionDocumentId
            text: (type): text
            weight: (number): weight

        Returns:
            application/json;charset=UTF-8
        """

        all_api_parameters = {'emotionDocumentId': {'name': 'emotionDocumentId', 'required': True, 'in': 'query'}, 'text': {'name': 'text', 'required': True, 'in': 'body'}, 'weight': {'name': 'weight', 'required': False, 'in': 'query'}}
        parameters_names_map = {}
        api = '/emotions-documents/edit'
        actions = ['post']
        params, data = self._format_params_for_api(locals(), all_api_parameters, parameters_names_map)
        return self._process_api(self._controller_name, api, actions, params, data)

    def list(self, emotionLanguageId, **kwargs):
        """

        Args:
            emotionLanguageId: (string): emotionLanguageId
            maxLength: (integer): maxLength
            maxNumber: (integer): maxNumber
            offset: (integer): offset
            sortMode: (string): { "weight", "proximity", "doc2vec", "keywords", "entities" }
            sortOrderAscending: (boolean): true = ascending (default); false = descending

        Returns:
            application/json;charset=UTF-8
        """

        all_api_parameters = {'emotionLanguageId': {'name': 'emotionLanguageId', 'required': True, 'in': 'query'}, 'maxLength': {'name': 'maxLength', 'required': False, 'in': 'query'}, 'maxNumber': {'name': 'maxNumber', 'required': False, 'in': 'query'}, 'offset': {'name': 'offset', 'required': False, 'in': 'query'}, 'sortMode': {'name': 'sortMode', 'required': False, 'in': 'query'}, 'sortOrderAscending': {'name': 'sortOrderAscending', 'required': False, 'in': 'query'}}
        parameters_names_map = {}
        api = '/emotions-documents/list'
        actions = ['post']
        params, data = self._format_params_for_api(locals(), all_api_parameters, parameters_names_map)
        return self._process_api(self._controller_name, api, actions, params, data)

    def remove(self, emotionDocumentId):
        """

        Args:
            emotionDocumentId: (string): emotionDocumentId

        Returns:
            application/json;charset=UTF-8
        """

        all_api_parameters = {'emotionDocumentId': {'name': 'emotionDocumentId', 'required': True, 'in': 'query'}}
        parameters_names_map = {}
        api = '/emotions-documents/remove'
        actions = ['post']
        params, data = self._format_params_for_api(locals(), all_api_parameters, parameters_names_map)
        return self._process_api(self._controller_name, api, actions, params, data)

    def retrieve(self, emotionDocumentId):
        """

        Args:
            emotionDocumentId: (string): emotionDocumentId

        Returns:
            application/json;charset=UTF-8
        """

        all_api_parameters = {'emotionDocumentId': {'name': 'emotionDocumentId', 'required': True, 'in': 'query'}}
        parameters_names_map = {}
        api = '/emotions-documents/retrieve'
        actions = ['post']
        params, data = self._format_params_for_api(locals(), all_api_parameters, parameters_names_map)
        return self._process_api(self._controller_name, api, actions, params, data)
