from edison_dictionary_api import EdisonBaseAPI


class featureClassesController(EdisonBaseAPI):
    """Features classes."""

    _controller_name = "featureClassesController"

    def add(self, code, **kwargs):
        """

        Args:
            code: (string): code
            description: (string): description

        Returns:
            application/json;charset=UTF-8
        """

        all_api_parameters = {'code': {'name': 'code', 'required': True, 'in': 'query'}, 'description': {'name': 'description', 'required': False, 'in': 'query'}}
        parameters_names_map = {}
        api = '/feature-classes/add'
        actions = ['post']
        params, data = self._format_params_for_api(locals(), all_api_parameters, parameters_names_map)
        return self._process_api(self._controller_name, api, actions, params, data)

    def edit(self, featureClassId, **kwargs):
        """

        Args:
            description: (string): description
            featureClassId: (string): featureClassId

        Returns:
            application/json;charset=UTF-8
        """

        all_api_parameters = {'description': {'name': 'description', 'required': False, 'in': 'query'}, 'featureClassId': {'name': 'featureClassId', 'required': True, 'in': 'query'}}
        parameters_names_map = {}
        api = '/feature-classes/edit'
        actions = ['post']
        params, data = self._format_params_for_api(locals(), all_api_parameters, parameters_names_map)
        return self._process_api(self._controller_name, api, actions, params, data)

    def list(self):
        """"""

        all_api_parameters = {}
        parameters_names_map = {}
        api = '/feature-classes/list'
        actions = ['post']
        params, data = self._format_params_for_api(locals(), all_api_parameters, parameters_names_map)
        return self._process_api(self._controller_name, api, actions, params, data)

    def remove(self, featureClassId):
        """

        Args:
            featureClassId: (string): featureClassId

        Returns:
            application/json;charset=UTF-8
        """

        all_api_parameters = {'featureClassId': {'name': 'featureClassId', 'required': True, 'in': 'query'}}
        parameters_names_map = {}
        api = '/feature-classes/remove'
        actions = ['post']
        params, data = self._format_params_for_api(locals(), all_api_parameters, parameters_names_map)
        return self._process_api(self._controller_name, api, actions, params, data)

    def retrieve(self, featureClassId):
        """

        Args:
            featureClassId: (string): featureClassId

        Returns:
            application/json;charset=UTF-8
        """

        all_api_parameters = {'featureClassId': {'name': 'featureClassId', 'required': True, 'in': 'query'}}
        parameters_names_map = {}
        api = '/feature-classes/retrieve'
        actions = ['post']
        params, data = self._format_params_for_api(locals(), all_api_parameters, parameters_names_map)
        return self._process_api(self._controller_name, api, actions, params, data)
