from edison_dictionary_api import EdisonBaseAPI


class featureCodesController(EdisonBaseAPI):
    """Features-codes."""

    _controller_name = "featureCodesController"

    def add(self, featureClassId, name, subCode, **kwargs):
        """

        Args:
            description: (string): description
            featureClassId: (string): featureClassId
            name: (string): name
            subCode: (string): subCode

        Returns:
            application/json;charset=UTF-8
        """

        all_api_parameters = {'description': {'name': 'description', 'required': False, 'in': 'query'}, 'featureClassId': {'name': 'featureClassId', 'required': True, 'in': 'query'}, 'name': {'name': 'name', 'required': True, 'in': 'query'}, 'subCode': {'name': 'subCode', 'required': True, 'in': 'query'}}
        parameters_names_map = {}
        api = '/feature-codes/add'
        actions = ['post']
        params, data = self._format_params_for_api(locals(), all_api_parameters, parameters_names_map)
        return self._process_api(self._controller_name, api, actions, params, data)

    def edit(self, featureCodeId, **kwargs):
        """

        Args:
            description: (string): description
            featureCodeId: (string): featureCodeId
            name: (string): name

        Returns:
            application/json;charset=UTF-8
        """

        all_api_parameters = {'description': {'name': 'description', 'required': False, 'in': 'query'}, 'featureCodeId': {'name': 'featureCodeId', 'required': True, 'in': 'query'}, 'name': {'name': 'name', 'required': False, 'in': 'query'}}
        parameters_names_map = {}
        api = '/feature-codes/edit'
        actions = ['post']
        params, data = self._format_params_for_api(locals(), all_api_parameters, parameters_names_map)
        return self._process_api(self._controller_name, api, actions, params, data)

    def list(self, **kwargs):
        """

        Args:
            featureClassId: (string): featureClassId

        Returns:
            application/json;charset=UTF-8
        """

        all_api_parameters = {'featureClassId': {'name': 'featureClassId', 'required': False, 'in': 'query'}}
        parameters_names_map = {}
        api = '/feature-codes/list'
        actions = ['post']
        params, data = self._format_params_for_api(locals(), all_api_parameters, parameters_names_map)
        return self._process_api(self._controller_name, api, actions, params, data)

    def remove(self, featureCodeId):
        """

        Args:
            featureCodeId: (string): featureCodeId

        Returns:
            application/json;charset=UTF-8
        """

        all_api_parameters = {'featureCodeId': {'name': 'featureCodeId', 'required': True, 'in': 'query'}}
        parameters_names_map = {}
        api = '/feature-codes/remove'
        actions = ['post']
        params, data = self._format_params_for_api(locals(), all_api_parameters, parameters_names_map)
        return self._process_api(self._controller_name, api, actions, params, data)

    def retrieve(self, featureCodeId):
        """

        Args:
            featureCodeId: (string): featureCodeId

        Returns:
            application/json;charset=UTF-8
        """

        all_api_parameters = {'featureCodeId': {'name': 'featureCodeId', 'required': True, 'in': 'query'}}
        parameters_names_map = {}
        api = '/feature-codes/retrieve'
        actions = ['post']
        params, data = self._format_params_for_api(locals(), all_api_parameters, parameters_names_map)
        return self._process_api(self._controller_name, api, actions, params, data)
