from edison_dictionary_api import EdisonBaseAPI


class namesController(EdisonBaseAPI):
    """Names. """

    _controller_name = "namesController"

    def add(self, entityId, languageId, name):
        """

        Args:
            entityId: (string): entityId
            languageId: (string): languageId
            name: (string): name

        Returns:
            application/json;charset=UTF-8
        """

        all_api_parameters = {'entityId': {'name': 'entityId', 'required': True, 'in': 'query'}, 'languageId': {'name': 'languageId', 'required': True, 'in': 'query'}, 'name': {'name': 'name', 'required': True, 'in': 'query'}}
        parameters_names_map = {}
        api = '/names/add'
        actions = ['post']
        params, data = self._format_params_for_api(locals(), all_api_parameters, parameters_names_map)
        return self._process_api(self._controller_name, api, actions, params, data)

    def list(self, entityId):
        """

        Args:
            entityId: (string): entityId

        Returns:
            application/json;charset=UTF-8
        """

        all_api_parameters = {'entityId': {'name': 'entityId', 'required': True, 'in': 'query'}}
        parameters_names_map = {}
        api = '/names/list'
        actions = ['post']
        params, data = self._format_params_for_api(locals(), all_api_parameters, parameters_names_map)
        return self._process_api(self._controller_name, api, actions, params, data)

    def remove(self, nameId):
        """

        Args:
            nameId: (string): nameId

        Returns:
            application/json;charset=UTF-8
        """

        all_api_parameters = {'nameId': {'name': 'nameId', 'required': True, 'in': 'query'}}
        parameters_names_map = {}
        api = '/names/remove'
        actions = ['post']
        params, data = self._format_params_for_api(locals(), all_api_parameters, parameters_names_map)
        return self._process_api(self._controller_name, api, actions, params, data)

    def retrieve(self, nameId):
        """

        Args:
            nameId: (string): nameId

        Returns:
            application/json;charset=UTF-8
        """

        all_api_parameters = {'nameId': {'name': 'nameId', 'required': True, 'in': 'query'}}
        parameters_names_map = {}
        api = '/names/retrieve'
        actions = ['post']
        params, data = self._format_params_for_api(locals(), all_api_parameters, parameters_names_map)
        return self._process_api(self._controller_name, api, actions, params, data)
