from edison_dictionary_api import EdisonBaseAPI


class sentimentsBlacklistKeywordsController(EdisonBaseAPI):
    """Keywords from a blacklist of a sentiments"""

    _controller_name = "sentimentsBlacklistKeywordsController"

    def add(self, keyword, sentimentLanguageId):
        """

        Args:
            keyword: (string): keyword
            sentimentLanguageId: (string): sentimentLanguageId

        Returns:
            application/json;charset=UTF-8
        """

        all_api_parameters = {'keyword': {'name': 'keyword', 'required': True, 'in': 'query'}, 'sentimentLanguageId': {'name': 'sentimentLanguageId', 'required': True, 'in': 'query'}}
        parameters_names_map = {}
        api = '/sentiments-blacklist-keywords/add'
        actions = ['post']
        params, data = self._format_params_for_api(locals(), all_api_parameters, parameters_names_map)
        return self._process_api(self._controller_name, api, actions, params, data)

    def list(self, sentimentLanguageId, **kwargs):
        """

        Args:
            maxLength: (integer): maxLength
            maxNumber: (integer): maxNumber
            offset: (integer): offset
            sentimentLanguageId: (string): sentimentLanguageId
            sortOrderAscending: (boolean): true = ascending (default); false = descending

        Returns:
            application/json;charset=UTF-8
        """

        all_api_parameters = {'maxLength': {'name': 'maxLength', 'required': False, 'in': 'query'}, 'maxNumber': {'name': 'maxNumber', 'required': False, 'in': 'query'}, 'offset': {'name': 'offset', 'required': False, 'in': 'query'}, 'sentimentLanguageId': {'name': 'sentimentLanguageId', 'required': True, 'in': 'query'}, 'sortOrderAscending': {'name': 'sortOrderAscending', 'required': False, 'in': 'query'}}
        parameters_names_map = {}
        api = '/sentiments-blacklist-keywords/list'
        actions = ['post']
        params, data = self._format_params_for_api(locals(), all_api_parameters, parameters_names_map)
        return self._process_api(self._controller_name, api, actions, params, data)

    def remove(self, keywordId):
        """

        Args:
            keywordId: (string): keywordId

        Returns:
            application/json;charset=UTF-8
        """

        all_api_parameters = {'keywordId': {'name': 'keywordId', 'required': True, 'in': 'query'}}
        parameters_names_map = {}
        api = '/sentiments-blacklist-keywords/remove'
        actions = ['post']
        params, data = self._format_params_for_api(locals(), all_api_parameters, parameters_names_map)
        return self._process_api(self._controller_name, api, actions, params, data)

    def retrieve(self, keywordId):
        """

        Args:
            keywordId: (string): keywordId

        Returns:
            application/json;charset=UTF-8
        """

        all_api_parameters = {'keywordId': {'name': 'keywordId', 'required': True, 'in': 'query'}}
        parameters_names_map = {}
        api = '/sentiments-blacklist-keywords/retrieve'
        actions = ['post']
        params, data = self._format_params_for_api(locals(), all_api_parameters, parameters_names_map)
        return self._process_api(self._controller_name, api, actions, params, data)
