from edison_dictionary_api import EdisonBaseAPI


class sentimentsController(EdisonBaseAPI):
    """Sentiments"""

    _controller_name = "sentimentsController"

    def add(self, code, **kwargs):
        """

        Args:
            code: (string): code
            languageId: (string): languageId

        Returns:
            application/json;charset=UTF-8
        """

        all_api_parameters = {'code': {'name': 'code', 'required': True, 'in': 'query'}, 'languageId': {'name': 'languageId', 'required': False, 'in': 'query'}}
        parameters_names_map = {}
        api = '/sentiments/add'
        actions = ['post']
        params, data = self._format_params_for_api(locals(), all_api_parameters, parameters_names_map)
        return self._process_api(self._controller_name, api, actions, params, data)

    def list(self):
        """"""

        all_api_parameters = {}
        parameters_names_map = {}
        api = '/sentiments/list'
        actions = ['post']
        params, data = self._format_params_for_api(locals(), all_api_parameters, parameters_names_map)
        return self._process_api(self._controller_name, api, actions, params, data)

    def remove(self, sentimentId):
        """

        Args:
            sentimentId: (string): sentimentId

        Returns:
            application/json;charset=UTF-8
        """

        all_api_parameters = {'sentimentId': {'name': 'sentimentId', 'required': True, 'in': 'query'}}
        parameters_names_map = {}
        api = '/sentiments/remove'
        actions = ['post']
        params, data = self._format_params_for_api(locals(), all_api_parameters, parameters_names_map)
        return self._process_api(self._controller_name, api, actions, params, data)

    def retrieve(self, sentimentId):
        """

        Args:
            sentimentId: (string): sentimentId

        Returns:
            application/json;charset=UTF-8
        """

        all_api_parameters = {'sentimentId': {'name': 'sentimentId', 'required': True, 'in': 'query'}}
        parameters_names_map = {}
        api = '/sentiments/retrieve'
        actions = ['post']
        params, data = self._format_params_for_api(locals(), all_api_parameters, parameters_names_map)
        return self._process_api(self._controller_name, api, actions, params, data)
