from edison_dictionary_api import EdisonBaseAPI


class sentimentsKeywordsController(EdisonBaseAPI):
    """Sentiments keywords"""

    _controller_name = "sentimentsKeywordsController"

    def add(self, keyword, sentimentLanguageId, weight):
        """

        Args:
            keyword: (string): keyword
            sentimentLanguageId: (string): sentimentLanguageId
            weight: (number): weight

        Returns:
            application/json;charset=UTF-8
        """

        all_api_parameters = {'keyword': {'name': 'keyword', 'required': True, 'in': 'query'}, 'sentimentLanguageId': {'name': 'sentimentLanguageId', 'required': True, 'in': 'query'}, 'weight': {'name': 'weight', 'required': True, 'in': 'query'}}
        parameters_names_map = {}
        api = '/sentiments-keywords/add'
        actions = ['post']
        params, data = self._format_params_for_api(locals(), all_api_parameters, parameters_names_map)
        return self._process_api(self._controller_name, api, actions, params, data)

    def edit(self, keywordId, weight):
        """

        Args:
            keywordId: (string): keywordId
            weight: (number): weight

        Returns:
            application/json;charset=UTF-8
        """

        all_api_parameters = {'keywordId': {'name': 'keywordId', 'required': True, 'in': 'query'}, 'weight': {'name': 'weight', 'required': True, 'in': 'query'}}
        parameters_names_map = {}
        api = '/sentiments-keywords/edit'
        actions = ['post']
        params, data = self._format_params_for_api(locals(), all_api_parameters, parameters_names_map)
        return self._process_api(self._controller_name, api, actions, params, data)

    def list(self, sentimentLanguageId, **kwargs):
        """

        Args:
            maxLength: (integer): maxLength
            maxNumber: (integer): maxNumber
            offset: (integer): offset
            sentimentLanguageId: (string): sentimentLanguageId
            sortMode: (string): { "name", "weight" }
            sortOrderAscending: (boolean): true = ascending (default); false = descending

        Returns:
            application/json;charset=UTF-8
        """

        all_api_parameters = {'maxLength': {'name': 'maxLength', 'required': False, 'in': 'query'}, 'maxNumber': {'name': 'maxNumber', 'required': False, 'in': 'query'}, 'offset': {'name': 'offset', 'required': False, 'in': 'query'}, 'sentimentLanguageId': {'name': 'sentimentLanguageId', 'required': True, 'in': 'query'}, 'sortMode': {'name': 'sortMode', 'required': False, 'in': 'query'}, 'sortOrderAscending': {'name': 'sortOrderAscending', 'required': False, 'in': 'query'}}
        parameters_names_map = {}
        api = '/sentiments-keywords/list'
        actions = ['post']
        params, data = self._format_params_for_api(locals(), all_api_parameters, parameters_names_map)
        return self._process_api(self._controller_name, api, actions, params, data)

    def listForAllSentiments(self, **kwargs):
        """

        Args:
            languageId: (string): languageId
            minLevel: (number): minLevel

        Returns:
            application/json;charset=UTF-8
        """

        all_api_parameters = {'languageId': {'name': 'languageId', 'required': False, 'in': 'query'}, 'minLevel': {'name': 'minLevel', 'required': False, 'in': 'query'}}
        parameters_names_map = {}
        api = '/sentiments-keywords/listForAllSentiments'
        actions = ['post']
        params, data = self._format_params_for_api(locals(), all_api_parameters, parameters_names_map)
        return self._process_api(self._controller_name, api, actions, params, data)

    def remove(self, keywordId):
        """

        Args:
            keywordId: (string): keywordId

        Returns:
            application/json;charset=UTF-8
        """

        all_api_parameters = {'keywordId': {'name': 'keywordId', 'required': True, 'in': 'query'}}
        parameters_names_map = {}
        api = '/sentiments-keywords/remove'
        actions = ['post']
        params, data = self._format_params_for_api(locals(), all_api_parameters, parameters_names_map)
        return self._process_api(self._controller_name, api, actions, params, data)

    def retrieve(self, keywordId):
        """

        Args:
            keywordId: (string): keywordId

        Returns:
            application/json;charset=UTF-8
        """

        all_api_parameters = {'keywordId': {'name': 'keywordId', 'required': True, 'in': 'query'}}
        parameters_names_map = {}
        api = '/sentiments-keywords/retrieve'
        actions = ['post']
        params, data = self._format_params_for_api(locals(), all_api_parameters, parameters_names_map)
        return self._process_api(self._controller_name, api, actions, params, data)
