from edison_dictionary_api import EdisonBaseAPI


class themesDocumentsController(EdisonBaseAPI):
    """Themes documents"""

    _controller_name = "themesDocumentsController"

    def add(self, text, themeLanguageId, **kwargs):
        """

        Args:
            text: (type): text
            themeLanguageId: (string): themeLanguageId
            weight: (number): weight

        Returns:
            application/json;charset=UTF-8
        """

        all_api_parameters = {'text': {'name': 'text', 'required': True, 'in': 'body'}, 'themeLanguageId': {'name': 'themeLanguageId', 'required': True, 'in': 'query'}, 'weight': {'name': 'weight', 'required': False, 'in': 'query'}}
        parameters_names_map = {}
        api = '/themes-documents/add'
        actions = ['post']
        params, data = self._format_params_for_api(locals(), all_api_parameters, parameters_names_map)
        return self._process_api(self._controller_name, api, actions, params, data)

    def addFile(self, files, themeLanguageId, **kwargs):
        """Supported file formats: https://tika.apache.org/1.13/formats.html

        Args:
            files: (array): files
            splitByLines: (type): splitByLines
            themeLanguageId: (type): themeLanguageId

        Returns:
            application/json;charset=UTF-8
        """

        all_api_parameters = {'files': {'name': 'files', 'required': True, 'in': 'formData'}, 'splitByLines': {'name': 'splitByLines', 'required': False, 'in': 'formData'}, 'themeLanguageId': {'name': 'themeLanguageId', 'required': True, 'in': 'formData'}}
        parameters_names_map = {}
        api = '/themes-documents/addFile'
        actions = ['post']
        params, data = self._format_params_for_api(locals(), all_api_parameters, parameters_names_map)
        return self._process_api(self._controller_name, api, actions, params, data)

    def edit(self, text, themeDocumentId, **kwargs):
        """

        Args:
            text: (type): text
            themeDocumentId: (string): themeDocumentId
            weight: (number): weight

        Returns:
            application/json;charset=UTF-8
        """

        all_api_parameters = {'text': {'name': 'text', 'required': True, 'in': 'body'}, 'themeDocumentId': {'name': 'themeDocumentId', 'required': True, 'in': 'query'}, 'weight': {'name': 'weight', 'required': False, 'in': 'query'}}
        parameters_names_map = {}
        api = '/themes-documents/edit'
        actions = ['post']
        params, data = self._format_params_for_api(locals(), all_api_parameters, parameters_names_map)
        return self._process_api(self._controller_name, api, actions, params, data)

    def list(self, themeLanguageId, **kwargs):
        """

        Args:
            maxLength: (integer): maxLength
            maxNumber: (integer): maxNumber
            offset: (integer): offset
            sortMode: (string): { "weight", "proximity", "doc2vec", "keywords", "entities" }
            sortOrderAscending: (boolean): true = ascending (default); false = descending
            themeLanguageId: (string): themeLanguageId

        Returns:
            application/json;charset=UTF-8
        """

        all_api_parameters = {'maxLength': {'name': 'maxLength', 'required': False, 'in': 'query'}, 'maxNumber': {'name': 'maxNumber', 'required': False, 'in': 'query'}, 'offset': {'name': 'offset', 'required': False, 'in': 'query'}, 'sortMode': {'name': 'sortMode', 'required': False, 'in': 'query'}, 'sortOrderAscending': {'name': 'sortOrderAscending', 'required': False, 'in': 'query'}, 'themeLanguageId': {'name': 'themeLanguageId', 'required': True, 'in': 'query'}}
        parameters_names_map = {}
        api = '/themes-documents/list'
        actions = ['post']
        params, data = self._format_params_for_api(locals(), all_api_parameters, parameters_names_map)
        return self._process_api(self._controller_name, api, actions, params, data)

    def remove(self, themeDocumentId):
        """

        Args:
            themeDocumentId: (string): themeDocumentId

        Returns:
            application/json;charset=UTF-8
        """

        all_api_parameters = {'themeDocumentId': {'name': 'themeDocumentId', 'required': True, 'in': 'query'}}
        parameters_names_map = {}
        api = '/themes-documents/remove'
        actions = ['post']
        params, data = self._format_params_for_api(locals(), all_api_parameters, parameters_names_map)
        return self._process_api(self._controller_name, api, actions, params, data)

    def retrieve(self, themeDocumentId):
        """

        Args:
            themeDocumentId: (string): themeDocumentId

        Returns:
            application/json;charset=UTF-8
        """

        all_api_parameters = {'themeDocumentId': {'name': 'themeDocumentId', 'required': True, 'in': 'query'}}
        parameters_names_map = {}
        api = '/themes-documents/retrieve'
        actions = ['post']
        params, data = self._format_params_for_api(locals(), all_api_parameters, parameters_names_map)
        return self._process_api(self._controller_name, api, actions, params, data)
